/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/* ***************************************************** */

/**
 * @file LineExtend.h
 * @brief MGLineExtendTool クラスのインターフェイス
 */
#if !defined(AFX_LINEEXTEND_H__30681DA4_C8D5_455E_9499_1F862268BCF8__INCLUDED_)
#define AFX_LINEEXTEND_H__30681DA4_C8D5_455E_9499_1F862268BCF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/LocateState.h"

/// @class MGLineExtendTool LineExtend.h "CurveCmd/LineExtend.h"
///
/// 直線生成コマンドの「延長」オプション選択時に
/// 発動する state を表現するクラス。
class MGLineExtendTool : public MGLocateState
{
	UINT m_nIDS; ///< error message

	const MGCurve* m_curve;
	double m_param;

	// 生成オプション
	bool m_bBoth; ///< 端点を生成する線分の始点ではなく中点とするかどうか
	bool m_bEnd; ///< 元々の端点スナップの on/off 状態

public:
	// ソロでカレントコマンドとして利用する場合の ctor
	explicit MGLineExtendTool(fugenDoc* pDoc);

	// 直線生成コマンドから E キー押しで呼ぶ場合の ctor
	explicit MGLineExtendTool(MGCommandStateOwner* owner);

	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();

	virtual bool OnKeyDown(fugenView*, UINT, UINT, UINT);
	virtual bool OnLocated(const MGLocateInfo& info);
	virtual void do_make_temporary_display(mgSysGL& sgl,fugenView* pSView);

private:
	void prompt_message() const;
	std::unique_ptr<MGCurve> create_line(const MGPosition& epos) const;
};

#endif // !defined(AFX_LINEEXTEND_H__30681DA4_C8D5_455E_9499_1F862268BCF8__INCLUDED_)
